/* -*- mode: js2; js2-basic-offset: 4; indent-tabs-mode: nil -*- */
/*
  Copyright (c) 2012-2021, Dieter Schärf <ds@dschaerf.de>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

const Lang = imports.lang;

const Main = imports.ui.main;

const ExtensionUtils = imports.misc.extensionUtils;

const Me = ExtensionUtils.getCurrentExtension();

const Convenience = Me.imports.convenience;

const KEY_SHOW_DASH = 'show-dash';

const Dash = new Lang.Class({
    Name: 'Dash',

    _init: function() {
        this._settingsChangedId = Convenience.Settings.connect('changed::'+KEY_SHOW_DASH, Lang.bind(this, this._onChangedShowDash));
        this._onChangedShowDash();
    },

    _onChangedShowDash: function() {
        this._updateVisibility(Convenience.Settings.get_boolean(KEY_SHOW_DASH));
    },

    _updateVisibility: function(visible) {
        Main.overview._dash._container.visible = visible;
    },

    destroy: function() {
        Convenience.Settings.disconnect(this._settingsChangedId);
        this._updateVisibility(true);
    }
});

function get() {
    return new Dash();
}
